﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

// Buddy Stuff
using Styx.WoWInternals;

namespace BuddyProwl
{
    static class Events
    {
        #region Chat Events
        public static void handleBNWhisper(object sender, LuaEventArgs args)
        {
            if (BuddyProwl.Settings.Whisper)
            {
                object[] Args = args.Args;
                string message = Args[0].ToString();
                string presenceID = Args[12].ToString();
                string senderName = Lua.GetReturnValues(String.Format("return BNGetFriendInfoByID({0})", presenceID))[3];

                if (BuddyProwl.Settings.UseNotifo)
                    BuddyProwl.Pusher.PushList.Enqueue(new Notifo.PushMessage(senderName.Trim() + " (BN whisper)", message.Trim(), ObjectManager.Me.Name));

                Log.toFile(senderName.Trim() + " (BN whisper): " + message.Trim());
            }
        }

        public static void handleWhisper(WoWChat.ChatLanguageSpecificEventArgs e)
        {
            if (BuddyProwl.Settings.Whisper)
            {
                if (BuddyProwl.Settings.UseNotifo)
                    BuddyProwl.Pusher.PushList.Enqueue(new Notifo.PushMessage(e.Author.ToString().Trim() + " (whisper)", e.Message.ToString().Trim(), ObjectManager.Me.Name));

                Log.toFile(e.Author.ToString().Trim() + " (whisper): " + e.Message.ToString().Trim());
            }
        }

        public static void handleSay(WoWChat.ChatLanguageSpecificEventArgs e)
        {
            if (BuddyProwl.Settings.Say)
            {
                if (BuddyProwl.Settings.UseNotifo)
                    BuddyProwl.Pusher.PushList.Enqueue(new Notifo.PushMessage(e.Author.ToString().Trim() + " (say)", e.Message.ToString().Trim(), ObjectManager.Me.Name));

                Log.toFile(e.Author.ToString().Trim() + " (say): " + e.Message.ToString().Trim());
            }
        }

        public static void handleYell(WoWChat.ChatLanguageSpecificEventArgs e)
        {
            if (BuddyProwl.Settings.Yell)
            {
                if (BuddyProwl.Settings.UseNotifo)
                    BuddyProwl.Pusher.PushList.Enqueue(new Notifo.PushMessage(e.Author.ToString().Trim() + " (yell)", e.Message.ToString().Trim(), ObjectManager.Me.Name));

                Log.toFile(e.Author.ToString().Trim() + " (yell): " + e.Message.ToString().Trim());
            }
        }

        public static void handleGuild(WoWChat.ChatGuildEventArgs e)
        {
            if (BuddyProwl.Settings.Guild)
            {
                if (BuddyProwl.Settings.UseNotifo)
                    BuddyProwl.Pusher.PushList.Enqueue(new Notifo.PushMessage(e.Author.ToString().Trim() + " (guild)", e.Message.ToString().Trim(), ObjectManager.Me.Name));

                Log.toFile(e.Author.ToString().Trim() + " (guild): " + e.Message.ToString().Trim());
            }
        }

        public static void handleOfficer(WoWChat.ChatLanguageSpecificEventArgs e)
        {
            if (BuddyProwl.Settings.Guild)
            {
                if (BuddyProwl.Settings.UseNotifo)
                    BuddyProwl.Pusher.PushList.Enqueue(new Notifo.PushMessage(e.Author.ToString().Trim() + " (officer)", e.Message.ToString().Trim(), ObjectManager.Me.Name));

                Log.toFile(e.Author.ToString().Trim() + " (officer): " + e.Message.ToString().Trim());
            }
        }

        public static void handleParty(WoWChat.ChatLanguageSpecificEventArgs e)
        {
            if (BuddyProwl.Settings.Party)
            {
                if (BuddyProwl.Settings.UseNotifo)
                    BuddyProwl.Pusher.PushList.Enqueue(new Notifo.PushMessage(e.Author.ToString().Trim() + " (party)", e.Message.ToString().Trim(), ObjectManager.Me.Name));

                Log.toFile(e.Author.ToString().Trim() + " (party): " + e.Message.ToString().Trim());
            }
        }

        public static void handleBG(WoWChat.ChatLanguageSpecificEventArgs e)
        {
            if (BuddyProwl.Settings.Battleground)
            {
                if (BuddyProwl.Settings.UseNotifo)
                    BuddyProwl.Pusher.PushList.Enqueue(new Notifo.PushMessage(e.Author.ToString().Trim() + " (bg)", e.Message.ToString().Trim(), ObjectManager.Me.Name));

                Log.toFile(e.Author.ToString().Trim() + " (bg): " + e.Message.ToString().Trim());
            }
        }

        public static void handleEmote(WoWChat.ChatAuthoredEventArgs e)
        {
            if (BuddyProwl.Settings.Emote)
            {
                if (BuddyProwl.Settings.UseNotifo)
                    BuddyProwl.Pusher.PushList.Enqueue(new Notifo.PushMessage(e.Author.ToString().Trim() + " (emote)", e.Message.ToString().Trim(), ObjectManager.Me.Name));

                Log.toFile(e.Author.ToString().Trim() + " (emote): " + e.Message.ToString().Trim());
            }
        }

        public static void handleTextEmote(WoWChat.ChatAuthoredEventArgs e)
        {
            if (BuddyProwl.Settings.Emote)
            {
                if (BuddyProwl.Settings.UseNotifo)
                    BuddyProwl.Pusher.PushList.Enqueue(new Notifo.PushMessage(e.Author.ToString().Trim() + " (text emote)", e.Message.ToString().Trim(), ObjectManager.Me.Name));

                Log.toFile(e.Author.ToString().Trim() + " (text emote): " + e.Message.ToString().Trim());
            }
        }
        #endregion

        #region Player Events
        public static void handleLevelUp(EventArgs e)
        {
            if (BuddyProwl.Settings.LevelUp)
            {
                if (BuddyProwl.Settings.UseNotifo)
                    BuddyProwl.Pusher.PushList.Enqueue(new Notifo.PushMessage("[Level up]", "Congratulations! You are now level " + ObjectManager.Me.Level.ToString(), ObjectManager.Me.Name));

                Log.toFile("Leveled up to " + ObjectManager.Me.Level.ToString());
            }
        }

        public static void handleDeath()
        {
            if (BuddyProwl.Settings.Death)
            {
                if (BuddyProwl.Settings.UseNotifo)
                    BuddyProwl.Pusher.PushList.Enqueue(new Notifo.PushMessage("[Death]", "You died", ObjectManager.Me.Name));

                Log.toFile("You died");
            }
        }
        #endregion

        #region Other Events
        public static void handleAchievement(object sender, LuaEventArgs args)
        {
            if (BuddyProwl.Settings.Achievement)
            {
                string Name = Lua.GetReturnValues(String.Format("return GetAchievementInfo({0})", args.Args[0].ToString()))[1];

                if (BuddyProwl.Settings.UseNotifo)
                    BuddyProwl.Pusher.PushList.Enqueue(new Notifo.PushMessage("Achievement", Name, ObjectManager.Me.Name));

                Log.toFile("Earned: " + Name);
            }
        }

        public static void handleLootOpened(object sender, LuaEventArgs args)
        {
            if (BuddyProwl.Settings.Loot)
            {
                string lootstring = args.Args[0].ToString();
                if (lootstring.Contains("You receive"))
                {
                    string color_code = lootstring.Split('|')[1];
                    string item_name = lootstring.Split('[')[1].Split(']')[0];

                    // Check if epic or other rare item
                    if (color_code == "cffa335ee" || Array.Exists(Database.RareItems, s => s.Contains(item_name)))
                    {
                        if (BuddyProwl.Settings.UseNotifo)
                            BuddyProwl.Pusher.PushList.Enqueue(new Notifo.PushMessage("Loot", "Looted: " + item_name, ObjectManager.Me.Name));

                        Log.toFile("Looted: " + item_name);
                    }
                }
            }
        }
        #endregion
    }
}