﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Threading;
using System.Text;
using System.Windows.Forms;

namespace BuddyProwl
{
    public partial class frmConfig : Form
    {
        public frmConfig()
        {
            InitializeComponent();
            this.Icon = Icon.ExtractAssociatedIcon(Application.ExecutablePath);
        }

        private void frmConfig_Load(object sender, EventArgs e)
        {
            // Push Settings
            chkUseNotifo.Checked = BuddyProwl.Settings.UseNotifo;
            txtUsername.Text = BuddyProwl.Settings.Username;
            txtAPI.Text = BuddyProwl.Settings.APIKey;
            
            // What to push
            chkAchievement.Checked = BuddyProwl.Settings.Achievement;
            chkBattleground.Checked = BuddyProwl.Settings.Battleground;
            chkDeath.Checked = BuddyProwl.Settings.Death;
            chkEmote.Checked = BuddyProwl.Settings.Emote;
            chkGuild.Checked = BuddyProwl.Settings.Guild;
            chkLevelUp.Checked = BuddyProwl.Settings.LevelUp;
            chkParty.Checked = BuddyProwl.Settings.Party;
            chkSay.Checked = BuddyProwl.Settings.Say;
            chkWhisper.Checked = BuddyProwl.Settings.Whisper;
            chkYell.Checked = BuddyProwl.Settings.Yell;
            chkCheckLoot.Checked = BuddyProwl.Settings.Loot;
        }

        private void btnSave_Click(object sender, EventArgs e)
        {
            // Push Settings
            BuddyProwl.Settings.UseNotifo = chkUseNotifo.Checked;
            BuddyProwl.Settings.Username = txtUsername.Text;
            BuddyProwl.Settings.APIKey = txtAPI.Text;

            // What to push
            BuddyProwl.Settings.Achievement = chkAchievement.Checked;
            BuddyProwl.Settings.Battleground = chkBattleground.Checked;
            BuddyProwl.Settings.Death = chkDeath.Checked;
            BuddyProwl.Settings.Emote = chkEmote.Checked;
            BuddyProwl.Settings.Guild = chkGuild.Checked;
            BuddyProwl.Settings.LevelUp = chkLevelUp.Checked;
            BuddyProwl.Settings.Party = chkParty.Checked;
            BuddyProwl.Settings.Say = chkSay.Checked;
            BuddyProwl.Settings.Whisper = chkWhisper.Checked;
            BuddyProwl.Settings.Yell = chkYell.Checked;
            BuddyProwl.Settings.Loot = chkCheckLoot.Checked;

            // Save to file
            BuddyProwl.Settings.Save();

            // Reload the pusher with the new info
            BuddyProwl.Pusher.Reload(BuddyProwl.Settings.Username, BuddyProwl.Settings.APIKey);

            // Close config window
            this.Close();
        }

        private void btnTestAPIKey_Click(object sender, EventArgs e)
        {
            // Updates API-Key and uses it to send a message
            BuddyProwl.Settings.Username = txtUsername.Text;
            BuddyProwl.Settings.APIKey = txtAPI.Text;

            // Reload the pusher with the new info
            BuddyProwl.Pusher.Reload(BuddyProwl.Settings.Username, BuddyProwl.Settings.APIKey);

            try
            {
                BuddyProwl.Pusher.SendNotification("Your key seems to be working!", "Test", Database.Plugin_Name);
            }
            catch
            { }
        }
    }
}